/*************************GO-LICENSE-START*********************************
 * Copyright 2014 ThoughtWorks, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *************************GO-LICENSE-END***********************************/

package com.thoughtworks.go.domain.materials.mercurial;

import java.io.Serializable;

import com.thoughtworks.go.domain.materials.Revision;

public class StringRevision implements Revision, Serializable {
    protected final String revision;

    public StringRevision(String revision) {
        this.revision = revision;
    }

    public String getRevision() {
        return revision;
    }

    public String getRevisionUrl() {
        return getRevision();
    }

    public boolean isRealRevision() {
        return true;
    }

    public int hashCode() {
        return getRevision().hashCode();
    }

    public boolean equals(Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }

        StringRevision that = (StringRevision) o;

        if (!revision.equals(that.revision)) {
            return false;
        }

        return true;
    }

    public String toString() {
        return "StringRevision[" + getRevision() + "]";
    }
}
