--*************************GO-LICENSE-START*********************************
-- Copyright 2014 ThoughtWorks, Inc.
--
-- Licensed under the Apache License, Version 2.0 (the "License");
-- you may not use this file except in compliance with the License.
-- You may obtain a copy of the License at
--
--    http://www.apache.org/licenses/LICENSE-2.0
--
-- Unless required by applicable law or agreed to in writing, software
-- distributed under the License is distributed on an "AS IS" BASIS,
-- WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-- See the License for the specific language governing permissions and
-- limitations under the License.
--*************************GO-LICENSE-END***********************************

CREATE TABLE pipelineLabelCounts (
    id              BIGINT GENERATED BY DEFAULT AS IDENTITY (START WITH 1) PRIMARY KEY,
    pipelineName    VARCHAR(255),
    labelCount      BIGINT
);

ALTER TABLE pipelineLabelCounts ADD CONSTRAINT unique_pipeline_name UNIQUE (pipelineName);

-- Migrate existing pipeline label data to the new counter table

INSERT INTO pipelineLabelCounts (pipelineName, labelCount)
	(SELECT name, MAX(label) FROM pipelines GROUP BY name);


--//@UNDO

DROP TABLE pipelineLabelCounts IF EXISTS CASCADE;