/*************************GO-LICENSE-START*********************************
 * Copyright 2014 ThoughtWorks, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *************************GO-LICENSE-END***********************************/

package com.thoughtworks.go.config.update;


import com.thoughtworks.go.config.AgentConfig;
import com.thoughtworks.go.config.CruiseConfig;
import com.thoughtworks.go.config.UpdateConfigCommand;

/**
 * @understands updating resources on an agent
 */
public class UpdateResourceCommand implements UpdateConfigCommand {
    private String uuid;
    private String resources;

    public UpdateResourceCommand(String uuid, String resources) {
        this.uuid = uuid;
        this.resources = resources;
    }

    public CruiseConfig update(CruiseConfig cruiseConfig) throws Exception {
        AgentConfig agentConfig = cruiseConfig.agents().getAgentByUuid(uuid);
        agentConfig.getResources().importFromCsv(resources);
        return cruiseConfig;
    }
}
